package exercise;

import static java.util.Comparator.comparing;
import static java.util.stream.Collectors.groupingBy;
import static java.util.stream.Collectors.summingInt;
import java.util.List;
import java.util.Map;
import java.util.Optional;
public class Pass20_7 {

	public static void main(String[] args) {
		List<Sales> list = Sales.getList();
		
		// 担当者別の売上金額の合計
		Map<String, Integer> map =
				list.stream()
					.collect(groupingBy(
								Sales::getName,
								summingInt(s->s.getPc().getPrice()*s.getQuantity())
							));

		//	一番売り上げの高い担当者
		Optional<Map.Entry<String, Integer>> op = map.entrySet()
													  .stream()
													  .max(comparing(e->e.getValue()));
		System.out.print("\n最高売り上げの担当者＝");
		System.out.printf("%s:\\%,d ",op.get().getKey(),op.get().getValue());
		

		

		
		
		
		
		
		
		
		
	}

}
